(* Startovni cislo: 3 *)
uses crt;
const maxpolozek=10000;
type TPolozka=record
              id:string[10];
              jmeno:string[32];
              prijmeni:string[32];
              pohlavi:char;
              narozeni:string[4];
              umrti:string[4];
              matka:string[10];
              otec:string[10];
              end;

type Trodokmen=array[1..maxpolozek] of TPolozka;
type TXmlOpen=array[1..10] of record
              name:string[8];
              open:boolean;
              end;

var
 grDriver: Integer;
 grMode: Integer;
 ErrCode: Integer;
 f:text;
 rodokmen:TRodokmen;
 xmlopen:TXmlOpen;
 rodmax:word;
 a,b,c,d:word;
 rodpos:word;
 cmd:string;
 poltmp,poltmp2:TPolozka;
 s:string;
 y:word;
 fname:string;
 ch:char;
 i,code:integer;

Function UpCaseS(s:string):string;
var s2:string;
begin
s2[0]:=s[0];
For a:=1 to Length(s) do
 begin
 s2[a]:=UpCase(s[a]);
 end;
UpCaseS:=s2;
end;



Function GetByID(s:string):TPolozka;
var a:word;
    poltmp:TPolozka;
begin
poltmp.id:='';
poltmp.jmeno:='Osoba';
poltmp.prijmeni:='nenalezena!';
getbyid:=poltmp;
For a:=1 to rodmax do
 begin
 if UpCaseS(rodokmen[a].id)=UpCaseS(s) then
  begin
  getbyid:=rodokmen[a];
  exit;
  end;
 end;
end;

Procedure CheckEndPage;
var ch:char;
begin
Inc(y);
if y>=24 then
 begin
 y:=0;
 Write('Stiskni cokoliv ...');
 while keypressed do ch:=readkey;
 ch:=readkey;
 GotoXY(1,WhereY);
 ClrEol;
 end;
end;

Procedure Info(pol:TPolozka);
begin
  WriteLn('ID: ',pol.id);
  if (pol.jmeno<>'') then
   begin
   WriteLn('Jmeno: ',pol.jmeno);
   end;
  if (pol.prijmeni<>'') then
   begin
   WriteLn('Prijmeni: ',pol.prijmeni);
   end;
  if (pol.pohlavi<>#0) then
   begin
   Write('Pohlavi: ');
   if (UpCase(pol.pohlavi)='M') then WriteLn('Muz') else
   if (UpCase(pol.pohlavi)='Z') then WriteLn('Zena') else
    WriteLn('Neco zajimavyho');
   end;
  if (pol.narozeni<>'') then
   begin
   WriteLn('Narozeni: ',pol.narozeni);
   end;
  if (pol.umrti<>'') then
   begin
   WriteLn('Umrti: ',pol.umrti);
   end;
  if (pol.matka<>'') then
   begin
   poltmp:=GetByID(pol.matka);
   WriteLn('Matka: ',poltmp.jmeno,' ',poltmp.prijmeni);
   end;
  if (pol.otec<>'') then
   begin
   poltmp:=GetByID(pol.otec);
   WriteLn('Otec: ',poltmp.jmeno,' ',poltmp.prijmeni);
   end;
end;

Procedure SaveData;
var ch:char;
begin
Write('Ukladam data ...');
{$I-}
ReWrite(f);
If IOResult<>0 then
 begin
 WriteLn('Chyba pri ukladani!');
 Halt;
 end;
{$I-}
WriteLn(f,'<rodokmen>');
For a:=1 to rodmax do
 begin
 WriteLn(f,' <osoba>');
 WriteLn(f,'  <id>',rodokmen[a].id,'</id>');
 if rodokmen[a].jmeno='' then
  WriteLn(f,'  <jmeno/>')
   else
  WriteLn(f,'  <jmeno>',rodokmen[a].jmeno,'</jmeno>');
 if rodokmen[a].prijmeni='' then
  WriteLn(f,'  <prijmeni/>')
   else
  WriteLn(f,'  <prijmeni>',rodokmen[a].prijmeni,'</prijmeni>');
 if rodokmen[a].pohlavi=#0 then
  WriteLn(f,'  <pohlavi/>')
   else
  WriteLn(f,'  <pohlavi>',rodokmen[a].pohlavi,'</pohlavi>');
 if rodokmen[a].narozeni='' then
  WriteLn(f,'  <narozeni/>')
   else
  WriteLn(f,'  <narozeni>',rodokmen[a].narozeni,'</narozeni>');
 if rodokmen[a].umrti='' then
  WriteLn(f,'  <umrti/>')
   else
  WriteLn(f,'  <umrti>',rodokmen[a].umrti,'</umrti>');
 if rodokmen[a].matka='' then
  WriteLn(f,'  <matka/>')
   else
  WriteLn(f,'  <matka>',rodokmen[a].matka,'</matka>');
 if rodokmen[a].otec='' then
  WriteLn(f,'  <otec/>')
   else
  WriteLn(f,'  <otec>',rodokmen[a].otec,'</otec>');
 WriteLn(f,' </osoba>');
 end;
WriteLn(f,'</rodokmen>');
Close(f);
WriteLn('OK');
end;

Procedure Parse(s:string);
var s2:string;
    a,b,c:word;
    clos:boolean;
begin
a:=1;
repeat
if Length(s)=0 then Exit;
while (s[1]=' ') do
 begin
 s:=Copy(s,2,255);
 end;

if s[a]='<' then
 begin
 a:=a+1;
 b:=1;
 repeat
 s2[0]:=Chr(b);
 s2[b]:=s[a];
 a:=a+1;
 b:=b+1;
 until s[a]='>';
 if (s2[1]='/') then
  begin
  s2:=Copy(s2,2,255);
  clos:=true;
  end
   else
  clos:=false;
 For b:=1 to 10 do
  begin
  if (UpCaseS(s2)=xmlopen[b].name) then
   begin
   if (b=2) AND (clos) then
    begin
    if rodpos>maxpolozek then
     begin
     ClrScr;
     WriteLn('Soubor je prilis velky! Maximalni pocet polozek v souboru je ',maxpolozek);
     Halt;
     end;
    rodpos:=rodpos+1;
    rodokmen[rodpos].id:='';
    rodokmen[rodpos].jmeno:='';
    rodokmen[rodpos].prijmeni:='';
    rodokmen[rodpos].pohlavi:=#0;
    rodokmen[rodpos].narozeni:='';
    rodokmen[rodpos].umrti:='';
    rodokmen[rodpos].matka:='';
    rodokmen[rodpos].otec:='';
    end;
   xmlopen[b].open:=not clos;
   end;
  end;
 end;
if a=Length(s) then Exit;
if s[a+1]<>'<' then
 begin
 For b:=1 to 10 do
  begin
  if xmlopen[b].open then
   begin
   c:=b;
   end;
  end;
 b:=1;
 a:=a+1;
 repeat
 s2[b]:=s[a];
 b:=b+1;
 a:=a+1;
 until (s[a]='<') or (a=Length(s));
 s2[0]:=Chr(b-1);
 if c=3 then rodokmen[rodpos].id:=s2;
 if c=4 then rodokmen[rodpos].jmeno:=s2;
 if c=5 then rodokmen[rodpos].prijmeni:=s2;
 if c=6 then rodokmen[rodpos].pohlavi:=s2[1];
 if c=7 then rodokmen[rodpos].narozeni:=s2;
 if c=8 then rodokmen[rodpos].umrti:=s2;
 if c=9 then rodokmen[rodpos].matka:=s2;
 if c=10 then rodokmen[rodpos].otec:=s2;
 end
  else
 a:=a+1;
until a=Length(s);
end;

Procedure GetData;
var s:string;
begin
For a:=1 to 10 do xmlopen[a].open:=false;
repeat
ReadLn(f,s);
Parse(s);
until Eof(f);
Close(f);
end;

begin
rodmax:=1;
rodpos:=1;
xmlopen[1].name:='RODOKMEN';
xmlopen[2].name:='OSOBA';
xmlopen[3].name:='ID';
xmlopen[4].name:='JMENO';
xmlopen[5].name:='PRIJMENI';
xmlopen[6].name:='POHLAVI';
xmlopen[7].name:='NAROZENI';
xmlopen[8].name:='UMRTI';
xmlopen[9].name:='MATKA';
xmlopen[10].name:='OTEC';

if (ParamCount<>1) then
 begin
 Write('Nazev souboru pro nacteni: ');
 ReadLn(fname);
 end
  else
 fname:=ParamStr(1);
{$I-}
Assign(f,fname);
Reset(f);
If (IOResult<>0) then
 begin
 WriteLn('Chyba pri otevirani souboru!');
 Halt;
 end;
{$I+}

ClrScr;
Write('Nacitam data ...');
GetData;

ClrScr;
rodmax:=rodpos-1;
WriteLn('Vitejte v Rodokmenu 1.0');
WriteLn('Napis help<ENTER> pro napovedu');
WriteLn;
repeat
Write(fname,'> ');
ReadLn(cmd);
cmd:=UpCaseS(cmd);
if cmd='LIST' then
 begin
 y:=0;
 For a:=1 to rodmax do
  begin
  WriteLn(a,'. ',rodokmen[a].jmeno,' ',rodokmen[a].prijmeni);
  CheckEndPage;
  end;
 end
  else
if cmd='HELP' then
 begin
 WriteLn('Napoveda:');
 WriteLn;
 WriteLn('Podporovane prikazy:');
 WriteLn(' LIST     -  Vypsat osoby v databazi');
 WriteLn(' INFO     -  Vypsat informace o urcite osobe');
 WriteLn(' INFOBYID -  Vypsat Informace o urcite osobe podle ID');
 WriteLn(' ADD      -  Pridat osobu');
 WriteLn(' DELETE   -  Odebrat osobu');
 WriteLn(' EDIT     -  Editovat osobu');
 WriteLn(' SAVE     -  Ulozit data');
 WriteLn(' SAVEAS   -  Ulozit data do jineho souboru');
 WriteLn(' LOAD     -  Nacist data');
 WriteLn(' ADDFILE  -  Pridat souboru do aktualniho rodokmenu');
 WriteLn(' CLS      -  Vymazat obrazovku');
 WriteLn(' PARTNER  -  Vyhleda vsechny vhodne partnery pro urcitou osobu');
 WriteLn(' QUIT     -  Konec');
 end
  else
if cmd='INFO' then
 begin
 Write('Cislo osoby: ');
 ReadLn(a);
 If (a<=rodmax) AND (a>0) then
  begin
  Info(rodokmen[a]);
  end
   else
  begin
  WriteLn('Rozsah 1-',rodmax);
  end;
 end
  else
if cmd='INFOBYID' then
 begin
 Write('ID osoby: ');
 ReadLn(s);
 poltmp2:=GetByID(s);
 if poltmp2.id='' then
  begin
  WriteLn('Osoba nenalezena!');
  end
   else
  begin
  Info(poltmp2);
  end;
 end
  else
 if cmd='ADD' then
  begin
  rodmax:=rodmax+1;
  Write('ID: ');
  ReadLn(rodokmen[rodmax].id);
  Write('Jmeno: ');
  ReadLn(rodokmen[rodmax].jmeno);
  Write('Prijmeni: ');
  ReadLn(rodokmen[rodmax].prijmeni);
  Write('Pohlavi: ');
  repeat
  rodokmen[rodmax].pohlavi:=readkey;
  rodokmen[rodmax].pohlavi:=UpCase(rodokmen[rodmax].pohlavi);
  until (rodokmen[rodmax].pohlavi='M') OR (rodokmen[rodmax].pohlavi='Z');
  WriteLn(rodokmen[rodmax].pohlavi);
  Write('Rok narozeni: ');
  ReadLn(rodokmen[rodmax].narozeni);
  Write('Rok umrti: ');
  ReadLn(rodokmen[rodmax].umrti);
  Write('Matka: ');
  ReadLn(rodokmen[rodmax].matka);
  Write('Otec: ');
  ReadLn(rodokmen[rodmax].otec);
  end
  else
 if (cmd='SAVE') then
  begin
  SaveData;
  end
  else
 if (cmd='DELETE') OR (cmd='RM') then
  begin
  Write('Cislo polozky, kterou chcete smazat: ');
  ReadLn(b);
  For a:=b to rodmax do
   begin
   rodokmen[a]:=rodokmen[a+1];
   end;
  Dec(rodmax);
  end
  else
 if (cmd='EDIT') then
  begin
  Write('Cislo polozky, kterou chcete editovat: ');
  ReadLn(a);
  If (a<=rodmax) AND (a>0) then
   begin
   Write('ID (',rodokmen[a].id,'): ');
   ReadLn(rodokmen[a].id);
   Write('Jmeno (',rodokmen[a].jmeno,'): ');
   ReadLn(rodokmen[a].jmeno);
   Write('Prijmeni (',rodokmen[a].prijmeni,'): ');
   ReadLn(rodokmen[a].prijmeni);
   Write('Pohlavi (',rodokmen[a].pohlavi,'): ');
   repeat
   rodokmen[a].pohlavi:=readkey;
   rodokmen[a].pohlavi:=UpCase(rodokmen[a].pohlavi);
   until (rodokmen[a].pohlavi='M') OR (rodokmen[a].pohlavi='Z');
   WriteLn(rodokmen[a].pohlavi);
   Write('Rok narozeni (',rodokmen[a].narozeni,'): ');
   ReadLn(rodokmen[a].narozeni);
   Write('Rok umrti (',rodokmen[a].umrti,'): ');
   ReadLn(rodokmen[a].umrti);
   Write('Matka (',rodokmen[a].matka,'): ');
   ReadLn(rodokmen[a].matka);
   Write('Otec (',rodokmen[a].otec,'): ');
   ReadLn(rodokmen[a].otec);
   end
    else
   begin
   WriteLn('Rozsah 1-',rodmax);
   end;
  end
  else
 if (cmd='SAVEAS') then
  begin
  Write('Nazev souboru pro ulozeni: ');
  ReadLn(fname);
  Assign(f,fname);
  SaveData;
  end
  else
 if (cmd='LOAD') then
  begin
  Write('Nazev souboru pro nacteni: ');
  ReadLn(s);
  {$I-}
  Assign(f,s);
  Reset(f);
  If (IOResult<>0) then
   begin
   WriteLn('Soubor nelze otevrit!');
   ch:=readkey;
   Assign(f,fname);
   end
    else
   begin
   fname:=s;
   GetData;
   rodmax:=rodpos-1;
   end;
  {$I+}
  end
  else
 if (cmd='CLS') then
  begin
  ClrScr;
  end
  else
 if (cmd='ADDFILE') then
  begin
  Write('Nazev souboru pro pridani: ');
  ReadLn(s);
  {$I-}
  Assign(f,s);
  Reset(f);
  If (IOResult<>0) then
   begin
   WriteLn('Soubor nelze otevrit!');
   ch:=readkey;
   Assign(f,fname);
   end
  else
   begin
   rodpos:=rodmax+1;
   GetData;
   Assign(f,fname);
   rodmax:=rodpos-1;
   end;
  end
  else
 if (cmd='PARTNER') then
  begin
  Write('Cislo polozky, pro kterou hledate partnera: ');
  ReadLn(a);
  Write('Maximalni rozdil ve veku: ');
  ReadLn(b);
  If (a<=rodmax) AND (a>0) then
   begin
   For c:=1 to rodmax do
    begin
    Val(rodokmen[a].narozeni,i,code);
    Val(rodokmen[c].narozeni,d,code);
    if (i-d>=-b) AND (i-d<=b) AND (a<>c) then
     begin
     if (rodokmen[a].pohlavi='Z') AND (rodokmen[c].pohlavi='M') then
      WriteLn(rodokmen[c].jmeno,' ',rodokmen[c].prijmeni);
     if (rodokmen[a].pohlavi='M') AND (rodokmen[c].pohlavi='Z') then
      WriteLn(rodokmen[c].jmeno,' ',rodokmen[c].prijmeni);
     end;
    end;
   end
    else
   begin
   WriteLn('Rozsah 1-',rodmax);
   end;
  end
  else
 if (cmd='QUIT') then
  else
 if (cmd='EXIT') then
  else
 begin
 WriteLn('Tak to teda neznam. Zkuste napsat "help" pro napovedu');
 end;
until (cmd='QUIT') OR (cmd='EXIT');
end.
(* Koncove cislo: 3 *)
